#include <tk.h>
#include <X11/Xutil.h>
#include <X11/Xlib.h>
#include <string.h>
#include <tclInt.h>
#include <stdbool.h>

Bool toggleDetectableAutorepeat (Tcl_Interp*, Bool enable);
Display * getDisplay (Tcl_Interp * interp);
int tdar_Cmd(ClientData cdata, Tcl_Interp  *interp, int objc,  Tcl_Obj * CONST objv[]);


//Bool tkewa_running = false;

int tdar_Cmd(ClientData cdata, Tcl_Interp  *interp, int objc,  Tcl_Obj * CONST objv[]) {
  	int ret;
 	if (objc != 2) {
 		Tcl_SetObjResult(interp, Tcl_NewStringObj("Wrong argc", -1));
		return TCL_ERROR;
 	}
 	int len = 0;
 	char * arg;
 	arg = Tcl_GetString(objv[1]);
 	if ( strcmp(arg, "start") == 0) {
 		ret = toggleDetectableAutorepeat(interp, true);
 	} else if (strcmp(arg, "stop") == 0) {
 		ret = toggleDetectableAutorepeat(interp, false);
 	} else {
 		Tcl_SetObjResult(interp, Tcl_NewStringObj("Wrong arg: should be \"w start|stop\"", -1));
 		ret = TCL_ERROR;
 	}
 	return ret;
}

int Tdar_Init(Tcl_Interp *interp)  {
	if (Tcl_InitStubs(interp, TCL_VERSION, 0) == NULL) {
        	Tcl_SetObjResult(interp, Tcl_NewStringObj("Failed to init TclStubs", -1)); 
         	return TCL_ERROR;
	}
	if (Tk_InitStubs(interp, TK_VERSION, 0) == NULL) {
        	Tcl_SetObjResult(interp, Tcl_NewStringObj("Failed to init TkStubs", -1)); 
         	return TCL_ERROR;
	}
	Tcl_CreateObjCommand(interp,  "tdar", (Tcl_ObjCmdProc *)tdar_Cmd, NULL, NULL);
	return TCL_OK;
}

Display * getDisplay (Tcl_Interp * interp) {
	Display * display;
	display = Tk_Display(Tk_MainWindow(interp));
	return display;
}
int toggleDetectableAutorepeat (Tcl_Interp* interp, Bool enable) {
	Display * display;
	display = getDisplay(interp);
	if(display == NULL) {
		Tcl_SetObjResult(interp, Tcl_NewStringObj("Error while getting display connection to X server", -1));
		return TCL_ERROR;
	}
	Bool supported;
	Bool result = XkbSetDetectableAutoRepeat(display, enable, &supported);
	XFlush(display);
	if(!supported || enable != result) {
		Tcl_SetObjResult(interp, Tcl_NewStringObj("Could not set detectable autorepeat", -1));
		return TCL_ERROR;
	} else {
		return TCL_OK;
	}
}
